<?php

namespace App\Controller;

use App\Entity\Users;
use App\Repository\UsersRepository;
use App\Repository\WebResetterRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Security\Core\User\UserInterface;

class DashboardController extends AbstractController
{
    #[Route('/', name: 'dashboard')]
    public function dashboard(
        UserInterface $userInterface,
        UsersRepository $usersRepository,
        WebResetterRepository $webResetterRepository
    ): Response {
        /** @var Users $userInterface */
        $user = $usersRepository->findOneBy(['username' => $userInterface->getUsername()]);
        $devices = $user->getWebResetter();
        if ($user->isAdminAccess()) {
            $devices = $webResetterRepository->findAll();
        }
        return $this->render(
            'pages/dashboard.html.twig',
            [
                'webResetters' => $devices,
            ]
        );
    }
}
