<?php

namespace App\Entity;

use App\Repository\HistoryRepository;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: HistoryRepository::class)]
class History
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\ManyToOne(inversedBy: 'histroy')]
    #[ORM\JoinColumn(nullable: false)]
    private ?Users $user = null;

    #[ORM\Column]
    private \DateTimeImmutable $date;

    #[ORM\Column]
    private ?string $command = null;

    #[ORM\Column]
    private ?int $value = null;

    #[ORM\ManyToOne(inversedBy: 'history')]
    #[ORM\JoinColumn(nullable: false)]
    private ?WebResetter $device = null;

    public function __construct()
    {
        $this->date = new \DateTimeImmutable();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getUser(): ?Users
    {
        return $this->user;
    }

    public function setUser(?Users $user): self
    {
        $this->user = $user;

        return $this;
    }

    public function getDate(): ?\DateTimeImmutable
    {
        return $this->date;
    }

    public function getCommand(): ?string
    {
        return $this->command;
    }

    public function setCommand(string $command): self
    {
        $this->command = $command;

        return $this;
    }

    public function getValue(): ?int
    {
        return $this->value;
    }

    public function setValue(int $value): self
    {
        $this->value = $value;

        return $this;
    }

    public function getDevice(): ?WebResetter
    {
        return $this->device;
    }

    public function setDevice(?WebResetter $device): self
    {
        $this->device = $device;

        return $this;
    }

    public function getCommandText(): string
    {
        return match ($this->command) {
            '1' => 'short press',
            '2' => 'long press',
            '3' => 'set I2C address',
            '4' => 'set short delay',
            '5' => 'set long delay',
            default => $this->command,
        };
    }

    public function getValueText(): ?string
    {
        if ($this->command > 2) {
            return (string)$this->value;
        }
        return match ($this->value) {
            1 => 'power button',
            2 => 'reset button',
            default => (string)$this->value,
        };
    }
}
