<?php

namespace App\Entity;

use App\Repository\ServerRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: ServerRepository::class)]
class Server
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 255)]
    private ?string $Name = null;

    #[ORM\Column(length: 15)]
    private ?string $IpAddress = null;

    #[ORM\Column(length: 255)]
    private ?string $Apikey = null;

    #[ORM\OneToMany(mappedBy: 'Server', targetEntity: WebResetter::class)]
    private Collection $webResetters;

    public function __construct()
    {
        $this->webResetters = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->Name;
    }

    public function setName(string $Name): self
    {
        $this->Name = $Name;

        return $this;
    }

    public function getIpAddress(): ?string
    {
        return $this->IpAddress;
    }

    public function setIpAddress(string $IpAddress): self
    {
        $this->IpAddress = $IpAddress;

        return $this;
    }

    public function getApikey(): ?string
    {
        return $this->Apikey;
    }

    public function setApikey(string $Apikey): self
    {
        $this->Apikey = $Apikey;

        return $this;
    }

    /**
     * @return Collection<int, WebResetter>
     */
    public function getWebResetters(): Collection
    {
        return $this->webResetters;
    }

    public function addWebResetter(WebResetter $webResetter): self
    {
        if (!$this->webResetters->contains($webResetter)) {
            $this->webResetters->add($webResetter);
            $webResetter->setServer($this);
        }

        return $this;
    }

    public function removeWebResetter(WebResetter $webResetter): self
    {
        if ($this->webResetters->removeElement($webResetter)) {
            // set the owning side to null (unless already changed)
            if ($webResetter->getServer() === $this) {
                $webResetter->setServer(null);
            }
        }

        return $this;
    }
}
